Package: metaSeq
Type: Package
Title: Meta-analysis of RNA-Seq count data in multiple studies
Version: 1.50.0
Date: 2013-12-2
Author: Koki Tsuyuzaki, Itoshi Nikaido
Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
Depends: R (>= 2.13.0), NOISeq, snow, Rcpp
Description: The probabilities by one-sided NOISeq are combined by
        Fisher's method or Stouffer's method
License: Artistic-2.0
Packaged: 2025-10-30 04:56:46 UTC; biocbuild
biocViews: RNASeq, DifferentialExpression, Sequencing, ImmunoOncology
git_url: https://git.bioconductor.org/packages/metaSeq
git_branch: RELEASE_3_22
git_last_commit: 6be5378
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no

other.oneside.pvalues <-
function (Upper, Lower, weight = NULL) 
{
    if ((min(!is.na(Upper)) < 0) || (max(!is.na(Upper)) > 1)) {
        stop("Is this dataset (upper) pvalues? Some elements exceed 0 - 1 range. Please confirm first.\n")
    }
    if ((min(!is.na(Lower)) < 0) || (max(!is.na(Lower)) > 1)) {
        stop("Is this dataset (lower) pvalues? Some elements exceed 0 - 1 range. Please confirm first.\n")
    }
    if (nrow(Upper) != nrow(Lower)) {
        stop("Number of rows in upper p-values and lower p-values are different!\n")
    }
    if (ncol(Upper) != ncol(Lower)) {
        stop("Number of columns in upper p-values and lower p-values are different!\n")
    }
    if ((!is.null(weight)) && (ncol(Upper) != length(weight))) {
        A <- ncol(Upper)
        B <- length(weight)
        Call <- paste0("Number of column in p-value matrix is ", 
            A, " but length of weight vector is ", B, ". Please confirm first.\n")
        stop(Call)
    }
    l <- ncol(Upper)
    out <- sapply(1:l, function(x) {
        output <- list()
        length(output) <- 3
        names(output) <- c("upper", "lower", "weight")
        U <- Upper[, x]
        L <- Lower[, x]
        names(U) <- rownames(Upper)
        names(L) <- rownames(Lower)
        output$upper <- U
        output$lower <- L
        output$weight <- weight[x]
        return(output)
    })
    colnames(out) <- paste("Exp", 1:l)
    return(out)
}

######### testdata ########
testdata <- matrix(rpois(12*100, 500), ncol=12, nrow=100)
test.flag1 <- c(1,1,1,0,0,0, 1,1,1,0,0,0)
test.flag2 <- c("A","A","A","A","A","A", "B","B","B","B","B","B")

######### readData, meta.readData ########
cds11 <- NOISeq:::readData(data = testdata[, 1:6], factor = as.data.frame(test.flag1[1:6]))
cds12 <- NOISeq:::readData(data = testdata[, 7:12], factor = as.data.frame(test.flag1[7:12]))
cds13 <- NOISeq:::readData(data = testdata[, c(1,4)], factor = as.data.frame(test.flag1[c(1,4)]))
cds14 <- NOISeq:::readData(data = testdata[, c(1,4:5)], factor = as.data.frame(test.flag1[c(1,4:5)]))

cds2 <- meta.readData(data = testdata, factor = test.flag1, studies = test.flag2)
expect_equivalent(length(which(as.vector(cds11@assayData$exprs) == as.vector(cds2[[1]]@assayData$exprs))), 600)
expect_equivalent(length(which(as.vector(cds12@assayData$exprs) == as.vector(cds2[[2]]@assayData$exprs))), 600)


######### noiseq ########
result11 <- NOISeq:::noiseq(cds11, k = 0.5, norm = "tmm", replicates = "biological", factor = "test.flag1[1:6]", conditions = c(1, 0))
result12 <- NOISeq:::noiseq(cds12, k = 0.5, norm = "tmm", replicates = "biological", factor = "test.flag1[7:12]", conditions = c(1, 0))
result13 <- NOISeq:::noiseq(cds13, k = 0.5, norm = "tmm", replicates = "no", factor = "test.flag1[c(1, 4)]", conditions = c(1, 0))
result14 <- NOISeq:::noiseq(cds14, k = 0.5, norm = "tmm", replicates = "biological", factor = "test.flag1[c(1, 4:5)]", conditions = c(1, 0))
expect_equivalent(is(result11)[1], "Output")
expect_equivalent(is(result12)[1], "Output")
expect_equivalent(is(result13)[1], "Output")
expect_equivalent(is(result14)[1], "Output")
expect_equivalent(is(result11)[2], "myInfo")
expect_equivalent(is(result12)[2], "myInfo")
expect_equivalent(is(result13)[2], "myInfo")
expect_equivalent(is(result14)[2], "myInfo")

######## oneside.noiseq #########
factors <- test.flag1
e <- new.env()
e$factors <- factors
loc <- list()
length(loc) <- 3
e$loc[[1]] <- 1:6
e$loc[[2]] <- 7:12
e$loc[[3]] <- c(1,4)

result21 <- metaSeq:::oneside.noiseq(cds2[[1]], k = 0.5, norm = "tmm", replicates = "biological", factor = "e$factors[e$loc[[x]]]", conditions = c(1, 0), x = 1)
result22 <- metaSeq:::oneside.noiseq(cds2[[2]], k = 0.5, norm = "tmm", replicates = "biological", factor = "e$factors[e$loc[[x]]]", conditions = c(1, 0), x = 2)

expect_equivalent(nrow(result11@results), nrow(result21@results))
expect_equivalent(nrow(result12@results), nrow(result22@results))
expect_equivalent(ncol(result11@results), ncol(result21@results))
expect_equivalent(ncol(result12@results), ncol(result22@results))

######### other.oneside.pvalues ########
upper <- matrix(runif(300), ncol=3, nrow=100)
lower <- matrix(runif(300), ncol=3, nrow=100)
weight <- c(3,6,8)
result3 <- other.oneside.pvalues(upper, lower, weight)
expect_equivalent(length(result3), 9)
expect_equivalent(length(result3[,1]), 3)
expect_equivalent(length(result3[,2]), 3)
expect_equivalent(length(result3[,3]), 3)
expect_equivalent(length(result3[,1][[1]]), 100)
expect_equivalent(length(result3[,1][[2]]), 100)
expect_equivalent(length(result3[,1][[3]]), 1)
expect_equivalent(length(result3[,2][[1]]), 100)
expect_equivalent(length(result3[,2][[2]]), 100)
expect_equivalent(length(result3[,2][[3]]), 1)
expect_equivalent(length(result3[,3][[1]]), 100)
expect_equivalent(length(result3[,3][[2]]), 100)
expect_equivalent(length(result3[,3][[3]]), 1)

######### meta.oneside.noiseq ########
result4 <- meta.oneside.noiseq(cds2, k = 0.5, norm = "tmm", replicates = "biological", factor = test.flag1, conditions = c(1, 0), studies = test.flag2)
expect_equivalent(ncol(result4), 2)

######### parallel computing (snow) ########
cl <- snow:::makeCluster(4, "SOCK")
result5 <- meta.oneside.noiseq(cds2, k = 0.5, norm = "tmm", replicates = "biological", factor = test.flag1, conditions = c(1, 0), studies = test.flag2, cl = cl)
stopCluster(cl)
expect_equivalent(ncol(result5), 2)

######### Fisher / Stouffer ########
F <- Fisher.test(result4)
S <- Stouffer.test(result4)
expect_equivalent(length(F$Upper), 100)
expect_equivalent(length(S$Upper), 100)
expect_equivalent(length(F$Lower), 100)
expect_equivalent(length(S$Lower), 100)
expect_equivalent(length(F$Weight), 2)
expect_equivalent(length(S$Weight), 2)

result6 <- other.oneside.pvalues(upper, lower)
expect_error(Stouffer.test(result6))

meta.readData <-
function (data = NULL, factors = NULL, length = NULL, biotype = NULL, 
    chromosome = NULL, gc = NULL, studies = NULL) 
{
    if (is.null(studies)) {
        stop("Please specify \"studies\" at first!\n")
    }
    else if (!is.vector(factors)) {
        stop("Please \"factors\" parameter as vector.\n")
    }
    else if (!is.vector(studies)) {
        stop("Please \"studies\" parameter as vector.\n")
    }
    else if (length(factors) != length(studies)) {
        stop("Length of factors and that of studies are different!\n")
    }
    else {
        out <- list()
        l <- nlevels(as.factor(studies))
        length(out) <- l
        length2 <- NULL
        biotype2 <- NULL
        chromosome2 <- NULL
        gc2 <- NULL
        if (!is.null(length)) {
            length2 <- length
        }
        if (!is.null(biotype)) {
            biotype2 <- biotype
        }
        if (!is.null(chromosome)) {
            chromosome2 <- chromosome
        }
        if (!is.null(gc)) {
            gc2 <- gc
        }
        e <<- new.env()
        e$factors <- factors
        e$studies <- studies
        e$length <- length2
        e$biotype <- biotype2
        e$chromosome <- chromosome2
        e$gc <- gc2
        loc <- list()
        length(loc) <- l
        e$loc <- loc
        for (x in 1:l) {
            loc[[x]] <- which(e$studies == levels(as.factor(e$studies))[x])
            e$loc[[x]] <- loc[[x]]
            out[[x]] <- readData(data = data[, e$loc[[x]]], factors = as.data.frame(e$factors[e$loc[[x]]]), 
                length = e$length, biotype = e$biotype, chromosome = e$chromosome, 
                gc = e$gc)
        }
    }
    class(out) <- "metaExpressionSet"
    return(out)
}

Fisher.test <-
function (pvals, na.mode = "notignore") 
{
    l <- ncol(pvals)
    U <- pvals[1, 1][[1]]
    L <- pvals[2, 1][[1]]
    weight <- unlist(pvals["weight", ])
    for (i in 2:l) {
        U <- cbind(U, pvals[1, i][[1]])
        L <- cbind(L, pvals[2, i][[1]])
    }
    up <- c()
    low <- c()
    if (na.mode == "notignore") {
        up <- apply(U, 1, each.Fisher.test)
        low <- apply(L, 1, each.Fisher.test)
    }
    if (na.mode == "ignore") {
        up <- apply(U, 1, each.Fisher.ignore.test)
        low <- apply(L, 1, each.Fisher.ignore.test)
    }
    else {
        warnings("You have to specify na.mode as \"ignore\" or \"notignore\"")
    }
    list(Upper = up, Lower = low, Weight = weight)
}

each.Fisher.ignore.test <-
function (p) 
{
    loc <- setdiff(1:length(p), which(is.na(p)))
    if (length(loc) >= 1) {
        p <- p[loc]
        Xsq <- -2 * sum(log(p))
        pval <- 1 - pchisq(Xsq, df = 2 * length(p))
        return(pval)
    }
    else {
        return(NA)
    }
}

Reset.Accelerate.NOISeq <-
function () 
{
    env <- getNamespace("NOISeq")
    assignInNamespace("busca", original.busca, ns = "NOISeq", 
        envir = env)
    assignInNamespace("n.menor", original.n.menor, ns = "NOISeq", 
        envir = env)
}

oneside.noiseq <-
function (input, k = 0.5, norm = c("rpkm", "uqua", "tmm", "n"), 
    replicates = c("technical", "biological", "no"), factor = NULL, 
    conditions = NULL, pnr = 0.2, nss = 5, v = 0.02, lc = 1, 
    x = NULL) 
{
    env <- getNamespace("NOISeq")
    assignInNamespace("probdeg", custom.probdeg, ns = "NOISeq", 
        envir = env)
    assignInNamespace("MD", custom.MD, ns = "NOISeq", envir = env)
    k2 = 0.5
    norm2 = c("rpkm", "uqua", "tmm", "n")
    replicates2 = c("technical", "biological", "no")
    factor2 = NULL
    conditions2 = NULL
    pnr2 = 0.2
    nss2 = 5
    v2 = 0.02
    lc2 = 1
    if (k != 0.5) {
        k2 <- k
    }
    if (length(norm) != 4) {
        norm2 <- norm
    }
    if (length(replicates) != 3) {
        replicates2 <- replicates
    }
    if (!is.null(factor)) {
        factor2 <- factor
    }
    if (!is.null(conditions)) {
        conditions2 <- conditions
    }
    if (pnr != 0.2) {
        pnr2 <- pnr
    }
    if (nss != 5) {
        nss2 <- nss
    }
    if (v != 0.02) {
        v2 <- v
    }
    if (lc != 1) {
        lc2 <- lc
    }
    e2 <<- new.env()
    e2$k <- k2
    e2$norm <- norm2
    e2$replicates <- replicates2
    e2$factor <- factor2
    e2$conditions <- conditions2
    e2$pnr <- pnr2
    e2$nss <- nss2
    e2$v <- v2
    e2$lc <- lc2
    fff <- eval(parse(text = eval(parse(text = "e2$factor"))))
    A <- length(which(conditions[1] == fff))
    B <- length(which(conditions[2] == fff))
    if ((A == 1) && (B == 1)) {
        warning("Your dataset contains some non-replicated sample. \"replicates\" parameter is automatically selected as \"no\".\n")
        out <- NOISeq::noiseq(input, k = e2$k, norm = e2$norm, 
            replicates = "no", factor = e2$factor, conditions = e2$conditions, 
            pnr = e2$pnr, nss = e2$nss, v = e2$v, lc = e2$lc)
    }
    else {
        out <- NOISeq::noiseq(input, k = e2$k, norm = e2$norm, 
            replicates = e2$replicates, factor = e2$factor, conditions = e2$conditions, 
            pnr = e2$pnr, nss = e2$nss, v = e2$v, lc = e2$lc)
    }
    return(out)
    assignInNamespace("probdeg", original.probdeg, ns = "NOISeq", 
        envir = env)
    assignInNamespace("MD", original.MD, ns = "NOISeq", envir = env)
}

each.Stouffer.test <-
function (p, w) 
{
    if (missing(w)) {
        w <- rep(1, length(p))/length(p)
    }
    else {
        if (length(w) != length(p)) 
            stop("Length of p and w must equal!")
    }
    Zi <- qnorm(1 - p)
    Z <- sum(w * Zi)/sqrt(sum(w^2))
    pval <- 1 - pnorm(Z)
    return(pval)
}

Accelerate.NOISeq <-
function (OS = NULL) 
{
    if (OS == "Unix") {
        data(text.n.menor_unix)
        data(text.busca_unix)
        env <- getNamespace("NOISeq")
        sourceCpp(code = text.n.menor_unix)
        sourceCpp(code = text.busca_unix)
        assignInNamespace("busca", busca, ns = "NOISeq", envir = env)
        assignInNamespace("n.menor", nmenor, ns = "NOISeq", envir = env)
    }
    if (OS == "Windows") {
        data(text.n.menor_win)
        data(text.busca_win)
        env <- getNamespace("NOISeq")
        sourceCpp(code = text.n.menor_win)
        sourceCpp(code = text.busca_win)
        assignInNamespace("busca", busca, ns = "NOISeq", envir = env)
        assignInNamespace("n.menor", nmenor, ns = "NOISeq", envir = env)
    }
    else {
        warning("Please specify OS as Unix or Windows!")
    }
}

each.Stouffer.ignore.test <-
function (p, w) 
{
    if (missing(w)) {
        w <- rep(1, length(p))/length(p)
    }
    else {
        if (length(w) != length(p)) 
            stop("Length of p and w must equal!")
    }
    loc <- setdiff(1:length(p), which(is.na(p)))
    if (length(loc) >= 1) {
        p <- p[loc]
        w <- w[loc]
        Zi <- qnorm(1 - p)
        Z <- sum(w * Zi)/sqrt(sum(w^2))
        pval <- 1 - pnorm(Z)
        return(pval)
    }
    else {
        return(NA)
    }
}

original.MD <-
function (dat = dat, selec = c(1:nrow(dat))) 
{
    pares <- as.matrix(combn(ncol(dat), 2))
    if (NCOL(pares) > 30) {
        sub30 <- sample(1:NCOL(pares), size = 30, replace = FALSE)
        pares <- pares[, sub30]
    }
    mm <- NULL
    dd <- NULL
    for (i in 1:ncol(pares)) {
        a <- dat[selec, pares[1, i]]
        b <- dat[selec, pares[2, i]]
        mm <- cbind(mm, log(a/b, 2))
        dd <- cbind(dd, abs(a - b))
    }
    list(M = mm, D = dd)
}

meta.oneside.noiseq <-
function (input, k = 0.5, norm = c("rpkm", "uqua", "tmm", "n"), 
    replicates = c("technical", "biological", "no"), factor = NULL, 
    conditions = NULL, pnr = 0.2, nss = 5, v = 0.02, lc = 1, 
    studies = NULL, cl = NULL) 
{
    if (inherits(input, "metaExpressionSet") == FALSE) {
        stop("Error. You must give an object generated by the meta.readData function or other.oneside.pvalues\n")
    }
    if (is.null(studies)) {
        stop("Please specify \"studies\" at first!\n")
    }
    else if (!is.vector(factor)) {
        stop("Please \"factor\" parameter as vector.\n")
    }
    else if (!is.vector(studies)) {
        stop("Please \"studies\" parameter as vector.\n")
    }
    else if (length(factor) != length(studies)) {
        stop("Length of factors and that of studies are different!\n")
    }
    else {
        out <- list()
        l <- length(input)
        length(out) <- l
        k2 = 0.5
        norm2 = c("rpkm", "uqua", "tmm", "n")
        replicates2 = c("technical", "biological", "no")
        conditions2 = NULL
        pnr2 = 0.2
        nss2 = 5
        v2 = 0.02
        lc2 = 1
        if (k != 0.5) {
            k2 <- k
        }
        if (length(norm) != 4) {
            norm2 <- norm
        }
        if (length(replicates) != 3) {
            replicates2 <- replicates
        }
        if (!is.null(conditions)) {
            conditions2 <- conditions
        }
        if (pnr != 0.2) {
            pnr2 <- pnr
        }
        if (nss != 5) {
            nss2 <- nss
        }
        if (v != 0.02) {
            v2 <- v
        }
        if (lc != 1) {
            lc2 <- lc
        }
        e <<- new.env()
        e$input <- input
        e$factors <- factor
        e$studies <- studies
        e$k <- k2
        e$norm <- norm2
        e$replicates <- replicates2
        e$conditions <- conditions2
        e$pnr <- pnr2
        e$nss <- nss2
        e$v <- v2
        e$lc <- lc2
        loc <- list()
        length(loc) <- l
        e$loc <- loc
        for (x in 1:l) {
            e$loc[[x]] <- which(levels(as.factor(e$studies))[x] == 
                e$studies)
        }
        if (!is.null(cl)) {
            clusterExport(cl, "e")
            out <- snow::parSapply(cl, 1:l, function(x) {
                output <- list()
                length(output) <- 3
                names(output) <- c("upper", "lower", "weight")
                result <- metaSeq:::oneside.noiseq(e$input[[x]], 
                  k = e$k, norm = e$norm, replicates = e$replicates, 
                  factor = "e$factors[e$loc[[x]]]", conditions = e$conditions, 
                  pnr = e$pnr, nss = e$nss, v = e$v, lc = e$lc, 
                  x = x)
                U <- result@results[[1]]$prob
                L <- 1 - result@results[[1]]$prob
                W <- nrow(input[[x]]@phenoData@data)
                names(U) <- rownames(input[[x]]@assayData$exprs)
                names(L) <- rownames(input[[x]]@assayData$exprs)
                output$upper <- U
                output$lower <- L
                output$weight <- W
                return(output)
            })
            colnames(out) <- paste("Study", 1:l)
            return(out)
        }
        else {
            out <- sapply(1:l, function(x) {
                output <- list()
                length(output) <- 3
                names(output) <- c("upper", "lower", "weight")
                result <- metaSeq:::oneside.noiseq(e$input[[x]], 
                  k = e$k, norm = e$norm, replicates = e$replicates, 
                  factor = "e$factors[e$loc[[x]]]", conditions = e$conditions, 
                  pnr = e$pnr, nss = e$nss, v = e$v, lc = e$lc, 
                  x = x)
                U <- result@results[[1]]$prob
                L <- 1 - result@results[[1]]$prob
                W <- nrow(input[[x]]@phenoData@data)
                names(U) <- rownames(input[[x]]@assayData$exprs)
                names(L) <- rownames(input[[x]]@assayData$exprs)
                output$upper <- U
                output$lower <- L
                output$weight <- W
                return(output)
            })
            colnames(out) <- paste("Study", 1:l)
            return(out)
        }
    }
}

custom.probdeg <-
function (Mg, Dg, Mn, Dn, prec = 2) 
{
    tot <- length(Mn)
    gens <- names(Mg)
    Mruido <- round(Mn, prec)
    Druido <- round(Dn, prec)
    Mgen <- round(Mg, prec)
    Dgen <- round(Dg, prec)
    MDgen <- na.omit(cbind(Mgen, Dgen))
    MDunic <- unique(MDgen)
    Nres <- apply(MDunic, 1, NOISeq:::n.menor, S1 = Mruido, S2 = Druido)
    lugares <- apply(MDgen, 1, NOISeq:::busca, S = MDunic)
    Nconj <- Nres[lugares]
    names(Nconj) <- names(lugares)
    laprob <- Nconj/tot
    laprob <- laprob[gens]
    names(laprob) <- gens
    Nconj <- Nconj[gens]
    names(Nconj) <- gens
    laprob <- list(prob = laprob, numDE = Nconj, numNOISE = tot)
    laprob
}

%\VignetteIndexEntry{metaSeq}
\documentclass[11pt]{article}
\usepackage{Sweave}
\usepackage{amsmath}
\usepackage{hyperref}
\usepackage{cite}
\usepackage[numbers]{natbib}
\usepackage{amssymb}
% keep.source: T => With comment out line in each chunk
\SweaveOpts{keep.source=TRUE,eps=FALSE,pdf=TRUE,png=TRUE,include=FALSE,concordance=TRUE}
\usepackage{url}
\usepackage[utf8]{inputenc}

\setlength{\textheight}{8.5in}
\setlength{\textwidth}{6in}
\setlength{\topmargin}{-0.25in}
\setlength{\oddsidemargin}{0.25in}
\setlength{\evensidemargin}{0.25in}
\newcommand{\Rpackage}[1]{{\textit{#1}}}

\usepackage{Sweave}
\begin{document}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}
\SweaveOpts{concordance=TRUE}

\title{\bf metaSeq: Meta-analysis of RNA-seq count data}
\author{Koki Tsuyuzaki$^1$, and Itoshi Nikaido$^2$.}
\maketitle
\begin{center}
\noindent
$^1$Department of Medical and Life Science, Tokyo University of Science.\\
\noindent
$^2$Bioinformatics Research Unit, Advanced Center for Computing and Communication, RIKEN.\\
\end{center}

\begin{center}
{\tt k.t.the-answer@hotmail.co.jp}
\end{center}
\tableofcontents

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\clearpage
<<echo=false>>=
options(width=70)
@
\newpage
\section{Introduction}
This document provides the way to perform meta-analysis of RNA-seq data using \Rpackage{metaSeq} package. Meta-analysis is a attempt to integrate multiple data in different studies and retrieve much reliable and reproducible result. In transcriptome study, the goal of analysis may be differentially expressed genes (DEGs). In our package, the probability of one-sided \Rpackage{NOISeq} \cite{NOISeq} is applied in each study. This is because the numbers of reads are often different depending on its study and \Rpackage{NOISeq} is robust method against its difference (see the next section). By meta-analysis, genes which differentially expressed in many studies are detected as DEGs.

\section{RSE: Read-Size Effect}
In many cases, the number of reads are depend on study. For example, here we prepared multiple RNA-Seq count data designed as Breast Cancer cell lines vs Normal cells measured in 4 different studies (this data is also accessible by $\bf{data(BreastCancer)}$).
\begin{center}
  \begin{table}[htbp]
    \begin{tabular}{|c|c|c|}\hline
      ID in this vignette & Accession (SRA / ERA Accession) & Experimental Design \\ \hline \hline
      StudyA & SRP008746 & Breast Cancer (n=3) vs Normal (n=2) \\ \hline
      StudyB & SRP006726 & Breast Cancer (n=1) vs Normal (n=1) \\ \hline
      StudyC & SRP005601 & Breast Cancer (n=7) vs Normal (n=1) \\ \hline
      StudyD & ERP000992 & Breast Cancer (n=2) vs Normal (n=1) \\ \hline
\end{tabular}
  \end{table}
\end{center}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{figure}[ht]
\centering
\includegraphics[width=80mm]{Fig1.jpeg}
\caption{Difference of the number of reads}
\label{fig1}
\end{figure}
\newpage
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
As shown in the figure 1, the number of reads in StudyA, B, C, and D are relatively different. Generally, statistical test is influenced by the number of reads; the more the number of reads is large, the more the statistical tests are tend to be significant (see the next section). Therefore, in meta-analysis of RNA-seq data, data may be suffered from this bias. Here we call this bias as RSE (Read Size Effect).

\section{Robustness against RSE}
In the point of view of robustness against RSE, we evaluated five widely used method in RNA-seq; \Rpackage{DESeq} \cite{DESeq}, \Rpackage{edgeR} \cite{edgeR}, \Rpackage{baySeq} \cite{baySeq}, and \Rpackage{NOISeq} \cite{NOISeq}. Here we used only StudyA data. All counts in the matrix are repeatedly down-sampled in accordance with distributions of binomial (the probability equals 0.5). 1 (original), 1/2, 1/4, 1/8, 1/16, and 1/32-fold data are prepared as low read size situation. In each read size, four methods are conducted (figure 2.A, this data is also accessible by $\bf{data(StudyA)}$ and $\bf{data(pvals)}$), then we focussed on how top500 genes of original data in order of significance will change its members, influenced by low read size (figure 2.B).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{figure}[ht]
\centering
\includegraphics[width=\linewidth]{Fig2.png}
\caption{A(left): RSE in each RNA-Seq method, B(right): Top 500 genes in order of significance}
\label{fig2}
\end{figure}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Ideal method will returns same result regardless of read size, because same data was used. As shown in figure 2, \Rpackage{NOISeq} is not almost affected by the number of reads and robustlly detects same genes as DEGs. Therefore, we concluded that \Rpackage{NOISeq} is suitable method at least in the point of view of meta-analysis. Note that probability of \Rpackage{NOISeq} is not equal to p-value; it is the probability that a gene is differentially expressed \cite{NOISeq}. Our package integrates its probability by Fisher's method \cite{Fisher} or Stouffer's method (inverse normal method) \cite{Stouffer}. In regard to Stouffer's method, weighting by the number of replicates (sample size) is used.
\clearpage

\section{Getting started}
At first, install and load the \Rpackage{metaSeq} and \Rpackage{snow}.
\begin{center}
<<echo=TRUE,print=FALSE>>=
library("metaSeq")
library("snow")
@
\end{center}

The RNA-seq expression data in breast cancer cell lines and normal cells is prepared. The data is measured from 4 different studies.The data is stored as a matrix (23368 rows $\times$ 18 columns).
\begin{center}
<<echo=TRUE,print=FALSE>>=
data(BreastCancer)
@
\end{center}

We need to prepare two vectors. First vector is for indicating the experimental condition (e.g., 1: Cancer, 2: Normal) and second one is for indicating the source of data (e.g., A: StudyA, B: StudyB, C: StudyC, D: StudyD).
\begin{center}
<<echo=TRUE,print=FALSE>>=
flag1 <- c(1,1,1,0,0, 1,0, 1,1,1,1,1,1,1,0, 1,1,0)
flag2 <- c("A","A","A","A","A", "B","B", "C","C","C","C","C","C","C","C", "D","D","D")
@
\end{center}

Then, we use $\bf{meta.readData}$ to create R object for $\bf{meta.oneside.noiseq}$.
\begin{center}
<<echo=TRUE,print=FALSE>>=
cds <- meta.readData(data = BreastCancer, factor = flag1, studies = flag2)
@
\end{center}

Onesided-NOISeq is performed in each studies and each probabilities are summalized as a member of list object.
\begin{center}
<<echo=TRUE,print=FALSE>>=
## This is very time consuming step.
# cl <- makeCluster(4, "SOCK")
# result <- meta.oneside.noiseq(cds, k = 0.5, norm = "tmm", replicates = "biological",
#  factor = flag1, conditions = c(1, 0), studies = flag2, cl = cl)
# stopCluster(cl)

## Please load pre-calculated result (Result.Meta)
## by data function instead of scripts above.
data(Result.Meta)
result <- Result.Meta
@
\end{center}
Fisher's method and Stouffer's method can be applied to the result of $\bf{meta.oneside.noiseq}$.
\begin{center}
<<echo=TRUE,print=FALSE>>=
F <- Fisher.test(result)
S <- Stouffer.test(result)
@
\end{center}
These outputs are summalized as list whose length is 3. First member is the probability which means a gene is upper-regulated genes, and Second member is lower-regulated genes. Weight in each study is also saved as its third member (weight is used only by Stouffer's method).
\clearpage
\begin{center}
<<echo=TRUE,print=FALSE>>=
head(F$Upper)
head(F$Lower)
F$Weight
head(S$Upper)
head(S$Lower)
S$Weight
@
\end{center}
\clearpage
Generally, by meta-analysis, detection power will improved and much genes are detected as DEGs.
\begin{center}
  \begin{table}[htbp]
    \begin{tabular}{|c|c|c|}\hline
      Method & Study & Number of DEGs \\ \hline \hline
      NOISeq & A & 86 \\ \hline
      NOISeq & B & 563 \\ \hline
      NOISeq & C & 99 \\ \hline
      NOISeq & D & 210 \\ \hline
      NOISeq & A, B, C, D (not meta-analysis) & 21  \\ \hline
      metaSeq (Fisher, Upper) & A, B, C, D & 407 \\ \hline
      metaSeq (Fisher, Lower)  & A, B, C, D & 1483 \\ \hline
      metaSeq (Stouffer, Upper) & A, B, C, D & 116 \\ \hline
      metaSeq (Stouffer, Lower) & A, B, C, D & 2271 \\ \hline
\end{tabular}
  \end{table}
\end{center}
\clearpage
\section{Meta-analysis by non-NOISeq method}
For some reason, we may want to use non-NOISeq method like \Rpackage{DESeq}, \Rpackage{edgeR}, or even cuffdiff \cite{cuffdiff}. We prepared other.oneside.noiseq as optional function for such methods. Returned object can be directlly applied to $\bf{Fisher.test}$ and $\bf{Stouffer.test}$.

We have to prepare at least 2 matrix filled with p-value or probability. First matrix is for upper-regulated genes between control group and treatment group. On the other hand, second matrix is for lower-regulated genes. As optional parameter, weight in each study is also avilable. Weight is need for Stouffer's method but not necessary for Fisher's method.
\begin{center}
<<echo=TRUE,print=FALSE>>=
## Assume this matrix as one-sided p-values
## generated by non-NOISeq method (e.g., cuffdiff)
upper <- matrix(runif(300), ncol=3, nrow=100)
lower <- 1 - upper
rownames(upper) <- paste0("Gene", 1:100)
rownames(lower) <- paste0("Gene", 1:100)
weight <- c(3,6,8)
@
\end{center}

Next, $\bf{other.oneside.pvalues}$ will return a list object for $\bf{Fisher.test}$ or $\bf{Stouffer.test}$ by upper, lower, and weight.
\begin{center}
<<echo=TRUE,print=FALSE>>=
## other.oneside.pvalues function return a matrix
## which can input Fisher.test or Stouffer.test
result <- other.oneside.pvalues(upper, lower, weight)
@
\end{center}

$\bf{result}$ above can be applied to $\bf{Fisher.test}$ and $\bf{Stouffer.test}$.
\begin{center}
<<echo=TRUE,print=FALSE>>=
F <- Fisher.test(result)
str(F)
head(F$Upper)
head(F$Lower)
F$Weight

S <- Stouffer.test(result)
str(S)
head(S$Upper)
head(S$Lower)
S$Weight
@
\end{center}
\newpage
\section{Setup}
This vignette was built on:
<<session>>=
sessionInfo()
@ 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newpage

\vspace{2cm}

\begin{thebibliography}{9}
% \providecommand{\natexlab}[1]{#1}
% \providecommand{\url}[1]{\texttt{#1}}
% \expandafter\ifx\csname urlstyle\endcsname\relax
%   \providecommand{\doi}[1]{doi: #1}\else
%   \providecommand{\doi}{doi: \begingroup \urlstyle{rm}\Url}\fi

\bibitem{NOISeq}
Tarazona, S. and Garcia-Alcalde, F. and Dopazo, J. and Ferrer, A. and Conesa, A.
\newblock {Genome Research}
\newblock \emph {Differential expression in RNA-seq: A matter of depth}, 21(12): 2213-2223, 2011.

\bibitem{DESeq}
Simon Anders and Wolfgang Huber
\newblock {Genome Biology}
\newblock \emph {Differential expression analysis for sequence count data.}, 11: R106, 2010.
  
\bibitem{edgeR}
Robinson, M. D. and McCarthy, D. J. and Smyth, G. K.
\newblock {Bioinformatics}
\newblock \emph {edgeR: a Bioconductor package for differential expression analysis of digital gene expression data.}, 26: 139-140, 2010
  
% \bibitem{DEGseq}
% Likun Wang and Xi Wang.
% \newblock{R package version 1.14.0.}
% \newblock \emph {DEGseq: Identify Differentially Expressed Genes from RNA-seq data.}

\bibitem{baySeq}
Thomas J. Hardcastle
\newblock{R package version 1.14.1.}
\newblock \emph {baySeq: Empirical Bayesian analysis of patterns of differential expression in count data.}, 2012. 

\bibitem{Fisher}
Fisher, R. A. 
\newblock {Statistical Methods for Research Workers, 4th edition,}
\newblock Oliver and Boyd, London, 1932.

\bibitem{Stouffer}
Stouffer, S. A. and Suchman, E. A. and DeVinney, L. C. and Star, S. A. and Williams, R. M. Jr. 
\newblock {The American Soldier, Vol. 1 - Adjustment during Army Life.} 
\newblock Princeton, Princeton University Press, 1949 

\bibitem{cuffdiff}
Trapnell, C. and Williams, B. A. and Pertea, G. and Mortazavi, A. and Kwan, G. and Baren, M. J. and Salzberg, S. L. and Wold, B. J. and Pachter, L.
\newblock {Nature biotechnology}
\newblock \emph {Transcript assembly and quantification by RNA-Seq reveals unannotated transcripts and isoform switching during cell differentiaiton}, 28: 511-515, 2010.

\end{thebibliography}

\end{document}

\name{meta.oneside.noiseq}
\alias{meta.oneside.noiseq}
\title{
One-sided NOISeq for meta-analysis
}
\description{
NOISeq customized for one-sided test in meta-analysis. Parallel computing is also available by snow package.
}
\usage{
meta.oneside.noiseq(input, k = 0.5, norm = c("rpkm", "uqua", "tmm", "n"), replicates = c("technical", "biological", "no"), factor = NULL, conditions = NULL, pnr = 0.2, nss = 5, v = 0.02, lc = 1, studies = NULL, cl = NULL)
}
\arguments{
  \item{input}{
Object of eSet class coming from readData function or other R packages such as DESeq.
}
  \item{k}{
Counts equal to 0 are replaced by k. By default, k = 0.5.
}
  \item{norm}{
Normalization method. It can be one of "rpkm" (default), "uqua" (upper quartile), "tmm" (trimmed mean of M) or "n" (no normalization).
}
  \item{replicates}{
In this argument, the type of replicates to be used is defined. Technical, biological or none. By default, technical replicates option is chosen.

\strong{Note that "no" is automatically chosen against the study which has no replicate.}
}
  \item{factor}{
A string indicating the name of factor whose levels are the conditions to be compared.
}
  \item{conditions}{
A vector containing the two conditions to be compared by the differential expression algorithm (needed when the factor contains more than 2 different conditions).
}
  \item{pnr}{
Percentage of the total reads used to simulated each sample when no replicates are available. By default, pnr = 0.2.
}
  \item{nss}{
Number of samples to simulate for each condition (nss>= 2). By default, nss = 5.
}
  \item{v}{
Variability in the simulated sample total reads. By default, v = 0.02. Sample total reads is computed as a random value from a uniform distribution in the interval [(pnr-v)*sum(counts), (pnr+v)*sum(counts)]
}
  \item{lc}{
Length correction is done by dividing expression by length^lc. By default, lc = 1.
}
  \item{studies}{
A vector specifying which column in data are measured in common study. Its length must be equal to the number of column in data.
}
  \item{cl}{
cluster object in snow pacakge.
}
}
\references{
Tarazona, S. and Garcia-Alcalde, F. and Dopazo, J. and Ferrer, A. and Conesa, A. (2011) Differential expression in RNA-seq: A matter of depth. \emph{Genome Research},
\bold{21(12)}: 2213-2223
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido
}
\seealso{
\code{\link[NOISeq]{noiseq}}
}
\examples{
data(BreastCancer)
library("snow")

# Experimental condition (1: BreastCancer, 0: Normal)
flag1 <- c(1,1,1,0,0, 1,0, 1,1,1,1,1,1,1,0, 1,1,0)

# Source of data
flag2 <- c("A","A","A","A","A", "B","B", "C","C","C","C","C","C","C","C", "D","D","D")

# readData function for meta-analysis
cds <- meta.readData(data = BreastCancer, factor = flag1, studies = flag2)

# oneside NOISeq for meta-analysis
# cl <- makeCluster(4, "SOCK")
# result <- meta.oneside.noiseq(cds, k = 0.5, norm = "tmm", replicates = "biological", factor = flag1, conditions = c(1, 0), studies = flag2, cl = cl)
# stopCluster(cl)

# Script above is very time-consumming step. Please use this pre-calculated result instead
data(Result.Meta)
result <- Result.Meta

# Fisher's method (without weighting)
F <- Fisher.test(result)
str(F)

# Stouffer's method (with weighting by sample-size)
S <- Stouffer.test(result)
str(S)
}

\name{Accelerate.NOISeq}
\alias{Accelerate.NOISeq}
\title{
Accelerating NOISeq
}
\description{
Exporting C++ re-implimated NOISeq to NOISeq namespace. Please use as
\bold{Accelerate.NOISeq(OS="Unix")}
or
\bold{Accelerate.NOISeq(OS="Windows")}
according to each OS.
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido
}

\name{Result.Meta}
\alias{Result.Meta}
\docType{data}
\title{
Result of meta.oneside.noiseq against Brast Cancer data
}
\description{
A matrix which containing the probability of oneside.noiseq in each study.
}
\usage{data(Result.Meta)}
\source{
\url{https://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP008746}

\url{http://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP006726}

\url{http://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP005601}

\url{http://trace.ddbj.nig.ac.jp/DRASearch/study?acc=ERP000992}
}
\references{
Hon, G. C. and Hawkins, R. D. and Caballero, O. L. and Lo, C et al. (2012) Global DNA hypomethylation coupled to repressive chromatin domain foormation and gene silencing in breast cancer. \emph{Genome Research}, \bold{22 (2)}: 246-258

Sun, Z. and Asmann, Y. W. and Kalari, K. R. and Bot, B. et al. (2011) Integrated analysis of gene expression, CpG island methylation, and gene copy number in breast cancer cells by deep sequencing. \emph{PLOS ONE}, \bold{25;6(2)}: e17490
}
\seealso{
       \code{\link{BreastCancer}}, \code{\link{meta.oneside.noiseq}}.
}
\examples{
data(Result.Meta)
}
\keyword{datasets}

\name{BreastCancer}
\alias{BreastCancer}
\docType{data}
\title{
Multiple RNA-Seq count data designed as Breast Cancer cell lines vs Normal cells
}
\description{
A data frame with 23368 rows (genes) with following 18 columns (samples).

All reads were measured by Illumina Genome Analyzer II or IIX, trimmed as 36 base, and mapped to the human reference genome hg19 as single-end. Each experimental design was restricted as Breast cancer cell vs Normal cell. Quality Control was performed by FastQC and samples whose quality scores were at least over 20 were choosed. Counts are quantified by HTSeq.
}
\usage{data(BreastCancer)}
\details{
StudyA: SRP008746
\itemize{
\item A_1: Breast Cancer (HCC1937), SRX099961, SRR350976

\item A_2: Breast Cancer (HCC3153), SRX101334, SRR353604_1

\item A_3: Breast Cancer (SUM131502), SRX101335, SRR353948_1

\item A_4: Normal (MCF10A), SRX099963, SRR353603_1

\item A_5: Normal (HCC2337), SRX101336, SRR353602_1
}

StudyB: SRP006726
\itemize{
\item B_1: Breast Cancer (HCC1954), SRX061997, SRR201983

\item B_2: Normal (HMEC), SRX061998, SRR201986
}

StudyC: SRP005601
\itemize{
\item C_1: Breast Cancer (BT20), SRX040501, SRR097786_1

\item C_2: Breast Cancer (BT474), SRX040502, SRR097787_1

\item C_3: Breast Cancer (MCF7), SRX040504, SRR097789_1

\item C_4: Breast Cancer (MDAMB231), SRX040505, SRR097790_1

\item C_5: Breast Cancer (MDAMB468), SRX040506, SRR097791_1

\item C_6: Breast Cancer (T47D), SRX040507, SRR097792_1

\item C_7: Breast Cancer (ZR751), SRX040508, SRR097793_1

\item C_8: Normal (MCF10A), SRX040503, SRR097788_1
}

StudyD: ERP000992
\itemize{
\item D_1: Breast Cancer (MCF7), ERX030989, ERR053953

\item D_2: Breast Cancer (T47D), ERX031000, ERR053958

\item D_3: Normal (Ishikawa), ERX030994, ERR053948
}
}
\source{
\url{https://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP008746}

\url{http://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP006726}

\url{http://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP005601}

\url{http://trace.ddbj.nig.ac.jp/DRASearch/study?acc=ERP000992}
}
\references{
Hon, G. C. and Hawkins, R. D. and Caballero, O. L. and Lo, C et al. (2012) Global DNA hypomethylation coupled to repressive chromatin domain foormation and gene silencing in breast cancer. \emph{Genome Research}, \bold{22 (2)}: 246-258

Sun, Z. and Asmann, Y. W. and Kalari, K. R. and Bot, B. et al. (2011) Integrated analysis of gene expression, CpG island methylation, and gene copy number in breast cancer cells by deep sequencing. \emph{PLOS ONE}, \bold{25;6(2)}: e17490
}
\seealso{
       \code{\link{StudyA}}, \code{\link{pvals}}.
}
\examples{
data(BreastCancer)
}
\keyword{datasets}

\name{text.busca_win}
\alias{text.busca_win}
\docType{data}
\title{
One of C++ re-implimated components in NOISeq
}
\description{
This object is imported to namespace of NOISeq in Windows machine
}
\keyword{datasets}

\name{text.busca_unix}
\alias{text.busca_unix}
\docType{data}
\title{
One of C++ re-implimated components in NOISeq
}
\description{
This object is imported to namespace of NOISeq in Unix machine
}
\keyword{datasets}

\name{meta.readData}
\alias{meta.readData}
\title{
readData function for meta-analysis
}
\description{
\code{\link[NOISeq]{readData}} function in NOISeq package customized for one-sided test in meta-analysis. Parallel computing is also available by snow package.
}
\usage{
meta.readData(data = NULL, factors = NULL, length = NULL, biotype = NULL, chromosome = NULL, gc = NULL, studies = NULL)
}
\arguments{
  \item{data}{
Matrix or data.frame containing the counts (or expression data) for each feature and sample. Features must be in rows and samples must be in columns.
}
  \item{factors}{
A data.frame containing the experimental condition or group for each sample (columns in the data object).
}
  \item{length}{
Optional argument.Vector, matrix or data.frame containing the length of each feature. In case of giving a vector, the names of the vector must be the feature names or ids with the same type of identifier used in data. If a matrix or a data.frame is provided, and it has two columns, it is expected that the feature names or ids are in the first column and the length of the features in the second. If it only has one column containing the length, the rownames of the object must be the feature names or ids.
}
  \item{biotype}{
Optional argument.Vector, matrix or data.frame containing the biological group (biotype) for each feature. In case of giving a vector, the names of the vector must be the feature names or ids with the same type of identifier used in data. If a matrix or a data.frame is provided, and it has two columns, it is expected that the feature names or ids are in the first column and the biotypes of the features in the second. If it only has one column containing the biotypes, the rownames of the object must be the feature names or ids.
}
  \item{chromosome}{
Optional argument. A matrix or data.frame containing the chromosome, start position and end position of each feature. The rownames must be the feature names or ids with the same type of identifier used in data.
}
  \item{gc}{
Optional argument.Vector, matrix or data.frame containing the GC content of each feature. In case of giving a vector, the names of the vector must be the feature names or ids with the same type of identifier used in data. If a matrix or a data.frame is provided, and it has two columns, it is expected that the feature names or ids are in the first column and the GC content of the features in the second. If it only has one column containing the GC content, the rownames of the object must be the feature names or ids.
}
  \item{studies}{
A vector specifying which column in data are measured in common study. Its length must be equal to the number of column in data.
}
}
\references{
Tarazona, S. and Garcia-Alcalde, F. and Dopazo, J. and Ferrer, A. and Conesa, A. (2011) Differential expression in RNA-seq: A matter of depth. \emph{Genome Research},
\bold{21(12)}: 2213-2223
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido
}
\seealso{
\code{\link[NOISeq]{readData}}
}
\examples{
data(BreastCancer)
library("snow")

# Experimental condition (1: BreastCancer, 0: Normal)
flag1 <- c(1,1,1,0,0, 1,0, 1,1,1,1,1,1,1,0, 1,1,0)

# Source of data
flag2 <- c("A","A","A","A","A", "B","B", "C","C","C","C","C","C","C","C", "D","D","D")

# readData function for meta-analysis
cds <- meta.readData(data = BreastCancer, factor = flag1, studies = flag2)

# oneside NOISeq for meta-analysis
# cl <- makeCluster(4, "SOCK")
# result <- meta.oneside.noiseq(cds, k = 0.5, norm = "tmm", replicates = "biological", factor = flag1, conditions = c(1, 0), studies = flag2, cl = cl)
# stopCluster(cl)

# Script above is very time-consumming step. Please use this pre-calculated result instead
data(Result.Meta)
result <- Result.Meta

# Fisher's method (without weighting)
F <- Fisher.test(result)
str(F)

# Stouffer's method (with weighting by sample-size)
S <- Stouffer.test(result)
str(S)
}

\name{other.oneside.pvalues}
\alias{other.oneside.pvalues}
\title{
Optional function for non-NOISeq method
}
\description{
Optional function for non-NOISeq method users. P-values or probability in one-sided test in positive and negative differentiation is integrated and converted as a input matrix for \code{Fisher.test} or \code{Stouffer.test}. Weight in each study can also be introduced.
}
\usage{
other.oneside.pvalues(Upper, Lower, weight = NULL)
}
\arguments{
  \item{Upper}{
A matrix which means p-values or probability in one-sided test (positive differentiation). Its rows mean "gene" and its columns mean "study"  that test was conducted.
}
  \item{Lower}{
A matrix which means p-values or probability in one-sided test (negative differentiation). Its rows mean "gene" and its columns mean "study"  that test was conducted.
}
  \item{weight}{
A vector which means weight in each study. Its length must be equal to the number of column in Upper and Lower.
}
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido
}
\examples{
## Assume these are one-sided p-value generated by non-NOISeq method (e.g., cufflinks)
upper <- matrix(runif(300), ncol=3, nrow=100)
lower <- 1 - upper
rownames(upper) <- paste0("Gene", 1:100)
rownames(lower) <- paste0("Gene", 1:100)
weight <- c(3,6,8)

# other.oneside.pvalues function return a matrix which can input Fisher.test or Stouffer.test
result <- other.oneside.pvalues(upper, lower, weight)

# Fisher's method (without weighting)
F <- Fisher.test(result)
str(F)

# Stouffer's method (with weighting by sample-size)
S <- Stouffer.test(result)
str(S)
}

\name{Reset.Accelerate.NOISeq}
\alias{Reset.Accelerate.NOISeq}
\title{
Reset Accelerate.NOISeq function
}
\description{
Reseting the result of Accelerate.NOISeq function and making NOISeq as normal mode. Just type
\bold{Reset.Accelerate.NOISeq()}
after running
\bold{Accelerate.NOISeq()}.
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido
}

\name{pvals}
\alias{pvals}
\docType{data}
\title{
P-values or probability calculated by DESeq, edgeR, baySeq, NOISeq, and DEGseq against StudyA
}
\description{
P-values or probability calculated by \pkg{DESeq}, \pkg{edgeR}, \pkg{baySeq}, \pkg{NOISeq}, and \pkg{DEGSeq} against \code{\link{StudyA}}, which was down-sampled simulation data (1, 1/2, 1/4, 1/8, 1/16, and 1/32).
}
\usage{data(pvals)}
\source{
\url{https://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP008746}
}
\seealso{
       \code{\link{StudyA}}, \code{\link{BreastCancer}}.
}
\examples{
data(pvals)
names(pvals)
}
\keyword{datasets}

\name{text.n.menor_unix}
\alias{text.n.menor_unix}
\docType{data}
\title{
One of C++ re-implimated components in NOISeq
}
\description{
This object is imported to namespace of NOISeq in Unix machine
}
\keyword{datasets}

\name{metaSeq-package}
\alias{metaSeq-package}
\alias{metaSeq}
\docType{package}
\title{
Meta-analysis of RNA-Seq count data in multiple studies
}
\description{
Meta-analysis for multiple studies's RNA-Seq count data. In this package, probability of gene differential is calculated by NOISeq, which is customized for one-sided test. One-sided probabilities are integrated by Fisher's method (without weighting) or Stouffer's method (with weighting by sample-size). P-values or probabilities calculated by non-NOISeq methods are also applicable by \code{other.oneside.pvalues}.
}
\details{
\tabular{ll}{
Package: \tab metaSeq\cr
Type: \tab Package\cr
Version: \tab 1.3.2\cr
Date: \tab 2013-12-2\cr
License: \tab Artistic-2.0\cr
}
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido

Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
}
\references{
Tarazona, S. and Garcia-Alcalde, F. and Dopazo, J. and Ferrer, A. and Conesa, A. (2011) Differential expression in RNA-seq: A matter of depth. \emph{Genome Research},
\bold{21(12)}: 2213-2223
}
\keyword{ package }
\seealso{
\code{\link[NOISeq]{readData}}, \code{\link[NOISeq]{noiseq}}
}

\name{Fisher.test}
\alias{Fisher.test}
\title{
Fisher's combined probability method
}
\description{
Fisher's method combines multiple p-values which are calculated in each study.
}
\usage{
Fisher.test(pvals, na.mode = "notignore")
}
\arguments{
  \item{pvals}{
A matrix coming from \code{\link{meta.oneside.noiseq}} function or \code{\link{other.oneside.pvalues}}, which is used for any one-sided p-values or probability.
}
  \item{na.mode}{
A string indicating how to treat NA in pvals. "notignore" means that genes having at least one NA is regarded as NA. "ignore" means NA is ignored and remaining data is used. By default, na.mode = "notignore".
}
}
\references{
Fisher, R. A. (1932) \emph{Statistical Methods for Research Workers}, \bold{4th edition}, Oliver and Boyd, London.
}
\author{
Koki Tsuyuzaki, Itoshi Nikaido
}
\seealso{
\code{\link{meta.readData}}, \code{\link{meta.oneside.noiseq}}, \code{\link{other.oneside.pvalues}}
}
\examples{
data(BreastCancer)
library("snow")

# Experimental condition (1: BreastCancer, 0: Normal)
flag1 <- c(1,1,1,0,0, 1,0, 1,1,1,1,1,1,1,0, 1,1,0)

# Source of data
flag2 <- c("A","A","A","A","A", "B","B", "C","C","C","C","C","C","C","C", "D","D","D")

# readData function for meta-analysis
cds <- meta.readData(data = BreastCancer, factor = flag1, studies = flag2)

# oneside NOISeq for meta-analysis
# cl <- makeCluster(4, "SOCK")
# result <- meta.oneside.noiseq(cds, k = 0.5, norm = "tmm", replicates = "biological", factor = flag1, conditions = c(1, 0), studies = flag2, cl = cl)
# stopCluster(cl)

# Script above is very time-consumming step. Please use this pre-calculated result instead
data(Result.Meta)
result <- Result.Meta

# Fisher's method (without weighting)
F <- Fisher.test(result)
str(F)

# Stouffer's method (with weighting by sample-size)
S <- Stouffer.test(result)
str(S)
}

\name{StudyA}
\alias{StudyA}
\docType{data}
\title{
Count data of SRP008746
}
\description{
Count data of SRP008746 used for simulation study. Original count data (\code{\link{BreastCancer}}) are down-sampled repeatedly in accordance with distributions of binomial (the probability equals 0.5). 1, 1/2, 1/4, 1/8, 1/16, and 1/32 data are prepared.
}
\usage{data(StudyA)}
\source{
\url{https://trace.ddbj.nig.ac.jp/DRASearch/study?acc=SRP008746}
}
\seealso{
       \code{\link{pvals}}, \code{\link{BreastCancer}}.
}
\examples{
data(StudyA)
}
\keyword{datasets}
